#
# spec file for package libvirt (Version 0.3.3)
#
# Copyright (c) 2010 SUSE LINUX Products GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#

# norootforbuild


Name:           libvirt
BuildRequires:  gettext gnutls-devel libxml2-devel ncurses-devel python python-devel readline-devel xen-devel
Url:            http://libvirt.org/
License:        LGPL v2.1 or later
Group:          Development/Libraries/C and C++
AutoReqProv:    yes
Version:        0.3.3
Release:        18.20.61
Summary:        A C toolkit to interract with the virtualization capabilities of Linux
Source0:        libvirt-%{version}.tar.bz2
Source1:        libvirtd.init
Source2:        libvirtd.conf
Patch0:         libvirt-xen-no-trailing-slash.patch
Patch1:         xen-3_2-hypercall.patch
Patch2:         attach-disk_fix.patch
Patch3:         socat.patch
Patch4:         libvirtd-defaults.patch
Patch5:         xen-maxmem.patch
Patch6:         detach-disk.patch
Patch7:         suse-network.patch
Patch8:         cve-2008-5086.patch
Patch9:         vnclisten.patch
Patch10:        adjust-vcpu-sockets.patch
Patch11:        cpu-topology.patch
Patch12:        CVE-2010-2242-nat.patch
Patch13:        xend-dev-detach.patch
Patch14:        xend-usb-tablet.patch
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
Requires:       xen libxml2 readline ncurses gnutls
Requires:       socat
ExclusiveArch:  %ix86 x86_64

%description
Libvirt is a C toolkit to interract with the virtualization
capabilities Linux. Virtualization of the Linux Operating System means
the ability to run multiple instances of Operating Systems concurently
on a single hardware system where the basic resources are driven by a
Linux instance. The library aims to provide long term stable C API
initially for the Xen paravirtualization but should be able to
integrate other virtualization mechanisms if needed.



Authors:
--------
    Daniel Veillard <veillard@redhat.com>
    Karel Zak <kzak@redhat.com>

%package devel
License:        LGPL v2.1 or later
Summary:        A C toolkit to interract with the virtualization capabilities of Linux
Group:          Development/Libraries/C and C++
Requires:       libvirt = %{version}

%description devel
Libvirt is a C toolkit to interract with the virtualization
capabilities Linux. Virtualization of the Linux Operating System means
the ability to run multiple instances of Operating Systems concurently
on a single hardware system where the basic resources are driven by a
Linux instance. The library aims to provide long term stable C API
initially for the Xen paravirtualization but should be able to
integrate other virtualization mechanisms if needed.



Authors:
--------
    Daniel Veillard <veillard@redhat.com>
    Karel Zak <kzak@redhat.com>

%package python
License:        LGPL v2.1 or later
Summary:        A C toolkit to interract with the virtualization capabilities of Linux
Group:          Development/Libraries/C and C++
Requires:       libvirt = %{version}
%py_requires

%description python
Libvirt is a C toolkit to interract with the virtualization
capabilities Linux. Virtualization of the Linux Operating System means
the ability to run multiple instances of Operating Systems concurently
on a single hardware system where the basic resources are driven by a
Linux instance. The library aims to provide long term stable C API
initially for the Xen paravirtualization but should be able to
integrate other virtualization mechanisms if needed.



Authors:
--------
    Daniel Veillard <veillard@redhat.com>
    Karel Zak <kzak@redhat.com>

%prep
%setup
%patch0 -p0
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1
%patch8 -p1
%patch9 -p1
%patch10 -p0
%patch11 -p0
%patch12 -p1
%patch13 -p1
%patch14 -p1

%build
export CFLAGS="$RPM_OPT_FLAGS"
%configure ac_cv_path_IPTABLES_PATH=/usr/sbin/iptables

make

%install
%{__rm} -rf $RPM_BUILD_ROOT
%makeinstall
(cd docs/examples ; make clean ; rm -rf .deps)
rm -f $RPM_BUILD_ROOT%{_libdir}/*.la
rm -f $RPM_BUILD_ROOT%{_libdir}/*.a
rm -f $RPM_BUILD_ROOT%{_libdir}/python*/site-packages/*.*a
rm -f $RPM_BUILD_ROOT%{_sysconfdir}/libvirt/qemu/networks/default.xml
rm -f $RPM_BUILD_ROOT%{_sysconfdir}/libvirt/qemu/networks/autostart/default.xml
#mkdir -p $RPM_BUILD_ROOT/etc/permissions.d
#cat > $RPM_BUILD_ROOT/etc/permissions.d/libvirt <<EOF
#%{_libdir}/libvirt_proxy root.root 4755
#EOF
rm -rf $RPM_BUILD_ROOT%{_libexecdir}/libvirt_proxy
rm -rf $RPM_BUILD_ROOT%{_datadir}/locale/as
rm -rf $RPM_BUILD_ROOT%{_datadir}/locale/hy
rm -rf $RPM_BUILD_ROOT%{_datadir}/locale/my
rm -rf $RPM_BUILD_ROOT%{_datadir}/locale/no
rm -rf $RPM_BUILD_ROOT%{_datadir}/locale/or
rm -rf $RPM_BUILD_ROOT%{_datadir}/locale/si
rm -rf $RPM_BUILD_ROOT%{_datadir}/locale/ur
mkdir -p $RPM_BUILD_ROOT/%{_localstatedir}/run/libvirt
mkdir -p $RPM_BUILD_ROOT/%{_localstatedir}/lib/libvirt
# init script
mkdir -p $RPM_BUILD_ROOT/etc/init.d
install %SOURCE1 $RPM_BUILD_ROOT/etc/init.d/libvirtd
ln -s /etc/init.d/libvirtd $RPM_BUILD_ROOT/usr/sbin/rclibvirtd
install -m644 %SOURCE2 $RPM_BUILD_ROOT/etc/libvirt/libvirtd.conf

%clean
%{__rm} -rf $RPM_BUILD_ROOT

%post
/sbin/ldconfig
%{fillup_and_insserv -f -y libvirtd}

%preun
%stop_on_removal libvirtd

%postun
/sbin/ldconfig
%restart_on_update libvirtd
%insserv_cleanup

%files
%defattr(-, root, root)
%doc README
%doc %{_mandir}/man1/virsh.1*
%{_sbindir}/libvirtd
%{_bindir}/virsh
%{_libdir}/lib*.so.*
#%attr(4755, root, root) %{_libexecdir}/libvirt_proxy
%dir %attr(0700, root, root) %{_sysconfdir}/libvirt/
%dir %attr(0700, root, root) %{_sysconfdir}/libvirt/qemu/
%dir %attr(0700, root, root) %{_sysconfdir}/libvirt/qemu/networks/
%dir %attr(0700, root, root) %{_sysconfdir}/libvirt/qemu/networks/autostart
%dir %{_localstatedir}/run/libvirt/
%dir %{_localstatedir}/lib/libvirt/
%config /etc/init.d/libvirtd
%{_sbindir}/rclibvirtd
%config %{_sysconfdir}/libvirt/libvirtd.conf
%doc %{_datadir}/doc/libvirt-%{version}/html/*
%dir %{_datadir}/doc/libvirt-%{version}
%dir %{_datadir}/doc/libvirt-%{version}/html
#/etc/permissions.d/libvirt
# Localization files
%{_datadir}/locale/*/LC_MESSAGES/*

%files devel
%defattr(-, root, root)
%{_libdir}/lib*.so
%{_includedir}/libvirt/*.h
%dir /usr/include/libvirt
%{_libdir}/pkgconfig/libvirt.pc
%doc %{_datadir}/gtk-doc/html/libvirt/*.devhelp
%doc %{_datadir}/gtk-doc/html/libvirt/*.html
%doc %{_datadir}/gtk-doc/html/libvirt/*.png
%doc %{_datadir}/gtk-doc/html/libvirt/*.css
%dir %{_datadir}/gtk-doc
%dir %{_datadir}/gtk-doc/html
%dir %{_datadir}/gtk-doc/html/libvirt
%doc docs/*.html docs/html docs/*.gif
%doc docs/examples
%doc docs/libvirt-api.xml
%doc %{_datadir}/doc/libvirt-python-%{version}/examples/*.py
%dir %{_datadir}/doc/libvirt-python-%{version}/examples
%doc %{_datadir}/doc/libvirt-python-%{version}/TODO
%dir %{_datadir}/doc/libvirt-python-%{version}

%files python
%defattr(-, root, root)
%doc AUTHORS NEWS README COPYING.LIB
%{_libdir}/python*/site-packages/libvirt.py*
%{_libdir}/python*/site-packages/libvirtmod*
%doc python/tests/*.py
%doc python/TODO
%doc python/libvirtclass.txt
%doc docs/examples/python

%changelog
* Thu Nov 11 2010 jfehlig@novell.com
- Fix tablet usbdevice parsing in xend driver
  bnc#651994
  xend-usb-tablet.patch
* Thu Nov 11 2010 jfehlig@novell.com
- Send 'force' and 'rm_cfg' options when invoking xend's
  device_destroy operation.
  bnc#651998
  xend-dev-detach.patch
* Thu Sep  2 2010 jfehlig@novell.com
- Fix detection of iptables path in spec file
  bnc#618155
* Fri Jul  9 2010 jfehlig@novell.com
- CVE-2010-2242 libvirt: improperly mapped source privileged ports
  may allow obtaining privileged resources on the host
  bnc#618155
  CVE-2010-2242-nat.patch
* Thu Jul  2 2009 wkong@novell.com
-Adjust vcpu sockets number to fix
  virsh vcpuinfo command doesn't work on SLES 10 SP2
  bnc#509728
  adjust-vcpu-sockets.patch
  cpu-topology.patch
* Mon Apr 20 2009 jfehlig@novell.com
- Disable libvirtd when not booted Xen.
  Fate#303604
* Thu Mar  5 2009 jfehlig@novell.com
- Use py_requires macro in spec file
  bnc#394453
* Mon Mar  2 2009 jfehlig@novell.com
- Fix s-expression parsing of vfb device.
  bnc#436629
  vnclisten.patch
* Mon Dec 15 2008 jfehlig@novell.com
- Patch for CVE-2008-5086
  bnc#459009
* Thu Nov 20 2008 jfehlig@novell.com
- Fix detach of blktap disk devices
  bnc#410644
- Expose networks managed outside of libvirt as read-only.
  bnc#441633
* Fri Nov  7 2008 jfehlig@novell.com
- Make libvirtd listen on unix domain socket by default
  bnc#397633
* Mon Oct  6 2008 jfehlig@novell.com
- Use xend vs hypercall interface to change max mem setting
  bnc#431766
* Wed Oct  1 2008 jfehlig@novell.com
- Added libvirtd.conf configuration file
- Disabled libvirtd listening on TLS by default.  Must be
  explicitly enabled in conf file.  libvirtd will only listen
  on Unix Domain Socket by default - accessed via ssh.
* Wed Oct  1 2008 jfehlig@novell.com
- Fix remote access of libvirtd via ssh.  Requires socat package.
* Wed Aug 13 2008 jfehlig@novell.com
- Package /var/lib/libvirt directory.  Needed by SnapshotService
  in libvirt-cim.
* Thu Jul 31 2008 jfehlig@novell.com
- Fix 'virsh attach-disk'.  bnc#410644
* Mon Apr 14 2008 jfehlig@novell.com
- Fix Xen 3.2 hypercalls.  bnc#378798
* Mon Nov 26 2007 jfehlig@novell.com
- Fixed libvirtd init script to pass '-d' (run as daemon) option.
* Fri Nov  9 2007 jfehlig@novell.com
- Updated to libvirt 0.3.3
  - Avahi mDNS daemon export
  - NUMA support
  - Various bug fixes
* Mon Oct 15 2007 jfehlig@novell.com
- Relax requirement of 'kernel' being specified in sexpr.
  Bug #275899
* Fri May  4 2007 ccoffing@novell.com
- libvirt was still returning incorrect VNC port for HVM guests.
  This is the other half of fix for bug #247417, which in turn
  fixes bug #237406.  This fixes the largest virt-manager stability
  issue.
* Fri Mar  2 2007 jfehlig@novell.com
- Added upstream patch that prevents libvirt from assuming vnc
  port is 5900 + domid when it cannot determine port from xend.
  Bug #247417.
* Tue Feb 20 2007 jfehlig@novell.com
- Removed usr/lib/libvirt_proxy setuid binary from package.  Fixes
  bug #246610.
* Fri Feb 16 2007 jfehlig@novell.com
- Updated to latest release.  Many of the issues seen in virt-manager
  have been caused by bugs / missing functionality in libvirt.  This
  upate provides a better basis for virt-manager.
* Wed Jan 10 2007 jfehlig@novell.com
- Updated to latest release, version 0.1.10.  Submitting to SLES10 SP1
  to provide base functionality for FATE feature 301181.
  - more localizations
  - bug fixes:
  - VCPU info breakages on xen 3.0.3
  - xenDaemonListDomains buffer overflow (Daniel Berrange)
  - reference count bug when creating Xen domains (Daniel Berrange)
  - improvements:
  - support graphic framebuffer for Xen paravirt (Daniel Berrange)
  - VNC listen IP range support (Daniel Berrange)
  - support for default Xen config files and inactive domains of 3.0.4 (Daniel Berrange)
* Fri Dec  8 2006 jfehlig@novell.com
- Updated to latest release, version 0.1.9.
  - python bindings: release interpeter lock when calling C (Daniel Berrange)
  - don't raise HTTP error when looking informations for a domain
  - some refactoring to use the driver for all entry points
  - better error reporting (Daniel Berrange)
  - fix OS reporting when running as non-root
  - provide XML parsing errors
  - extension of the test framework (Daniel Berrange)
  - fix the reconnect regression test
  - python bindings: Domain instances now link to the Connect to avoid garbage collection and disconnect
  - separate the notion of maximum memory and current use at the XML level
  - Fix a memory leak (Daniel Berrange)
  - add support for shareable drives
  - add support for non-bridge style networking configs for guests(Daniel Berrange)
  - python bindings: fix unsigned long marshalling (Daniel Berrange)
  - new config APIs virConfNew() and virConfSetValue() to build configs from scratch
  - hot plug device support based on Michel Ponceau patch
  - added support for inactive domains, new APIs, various associated cleanup (Daniel Berrange)
  - special device model for HVM guests (Daniel Berrange)
  - add API to dump core of domains (but requires a patched xend)
  - pygrub bootloader informations take over <os> informations
  - updated the localization strings
* Fri Oct 20 2006 jfehlig@novell.com
- Updated to latest release, version 0.1.8.
  - Bug for system with page size != 4k
  - vcpu number initialization (Philippe Berthault)
  - don't label crashed domains as shut off (Peter Vetere)
  - fix virsh man page (Noriko Mizumoto)
  - blktapdd support for alternate drivers like blktap (Daniel Berrange)
  - memory leak fixes (xend interface and XML parsing) (Daniel Berrange)
  - compile fix
  - mlock/munlock size fixes (Daniel Berrange)
  - improve error reporting
- Updated to latest release, version 0.1.7.
  - fix a memory bug on getting vcpu informations from xend (Daniel Berrange)
  - fix another problem in the hypercalls change in Xen changeset
    86d26e6ec89b when getting domain informations (Daniel Berrange)
* Tue Sep 26 2006 jfehlig@novell.com
- Updated to latest release, version 0.1.6.  This release includes
  fix in hypercall driver so local patch has been removed.
* Wed Sep 13 2006 jfehlig@novell.com
- Fixed bug in hypercall driver introduced in version 0.1.5.
  Patch sumbmitted upstream and included locally until next release.
* Mon Sep 11 2006 jfehlig@novell.com
- Updated to latest release, version 0.1.5
  - Support for new hypercalls change in Xen changeset 86d26e6ec89b
  - bug fixes: virParseUUID() was wrong, netwoking for paravirt guestsi
    (Daniel Berrange), virsh on non-existent domains (Daniel Berrange),
    string cast bug when handling error in python (Pete Vetere), HTTP
    500 xend error code handling (Pete Vetere and Daniel Berrange)
  - improvements: test suite for SEXPR <-> XML format conversions (Daniel
    Berrange), virsh output regression suite (Daniel Berrange), new environ
    variable VIRSH_DEFAULT_CONNECT_URI for the default URI when connecting
    (Daniel Berrange), graphical console support for paravirt guests
    (Jeremy Katz), parsing of simple Xen config files (with Daniel Berrange),
    early work on defined (not running) domains (Daniel Berrange),
    virsh output improvement (Daniel Berrange
* Mon Aug 28 2006 jfehlig@novell.com
- Updated to latest release, version 0.1.4
  - bug fixes: spec file fix (Mark McLoughlin), error report problem (with
    Hugh Brock), long integer in Python bindings (with Daniel Berrange), XML
    generation bug for CDRom (Daniel Berrange), bug whem using number() XPath
    function (Mark McLoughlin), fix python detection code, remove duplicate
    initialization errors (Daniel Berrange)
  - improvements: UUID in XML description (Peter Vetere), proxy code
    cleanup, virtual CPU and affinity support + virsh support (Michel
    Ponceau, Philippe Berthault, Daniel Berrange), port and tty informations
    for console in XML (Daniel Berrange), added XML dump to driver and proxy
    support (Daniel Berrange), extention of boot options with support for
    floppy and cdrom (Daniel Berrange), features block in XML to report/ask
    PAE, ACPI, APIC for HVM domains (Daniel Berrange), fail saide-effect
    operations when using read-only connection, large improvements to test
    driver (Daniel Berrange)
  - documentation: spelling (Daniel Berrange), test driver examples.
* Wed Aug 16 2006 jfehlig@novell.com
- Added ExclusiveArch tag so as to only build on x86 and x86_64
* Mon Jul 31 2006 jfehlig@novell.com
- initial submission of libvirt package, version 0.1.3
